#include <bits/stdc++.h>
using namespace std;

const int N = 100005;

int n, deck[N], pos[N];
int sz[N];
vector<int> vals[N];
vector<int> tree[N];
int pos_vals[N];

void push_val(int id) {
    for (int i = id + 1; i < N; i += i & -i)
        vals[i].push_back(deck[id]);
}

void modify(int id, int delta) {
    for (int i = id + 1; i < N; i += i & -i) {
        int pos_vals = lower_bound(vals[i].begin(), vals[i].end(), deck[id]) - vals[i].begin();
        for (int j = pos_vals + 1; j <= sz[i]; j += j & -j)
            tree[i][j] += delta;
    }
}

int inside_query(int i, int to) {
    int res = 0;
    for (int j = lower_bound(vals[i].begin(), vals[i].end(), to) - vals[i].begin(); j > 0; j -= j & -j)
        res += tree[i][j];
    return res;
}

int inside_query(int i, int from, int to) {
    return inside_query(i, to) - inside_query(i, from);
}

int query(int R, int from, int to) {
    int res = 0;
    for (int i = R; i > 0; i -= i & -i)
        res += inside_query(i, from, to);
    return res;
}

int query(int L, int R, int from, int to) {
    return query(R, from, to) - query(L, from, to);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> deck[i];
        --deck[i];
        pos[deck[i]] = i;
    }
    for (int i = 0; i < n; ++i)
        push_val(i);
    for (int i = 0; i < N; ++i) {
        sort(vals[i].begin(), vals[i].end());
        sz[i] = vals[i].size();
        tree[i].assign(sz[i] + 1, 0);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += query(0, i, deck[i] + 1, n);
        modify(i, 1);
    }
    cout << ans;
    for (int i = 0; i < n - 2; ++i) {
        int val;
        cin >> val;
        --val;
        int id = pos[val];
        ans -= query(0, id, val + 1, n);
        ans -= query(id + 1, n, 0, val);
        modify(id, -1);
        cout << " " << ans;
    }

    return 0;
}
