#include <algorithm>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (int64_t)(1e18)
#define EPS 1e-9

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

vector<int> tree;

int get(int v, int l, int r, int li, int ri) {
    if (l >= ri || li >= r)
        return 0;
    if (li <= l && r <= ri)
        return tree[v];
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, li, ri) + get(2 * v + 2, m, r, li, ri);
}

void update(int v, int l, int r, int ind, int x) {
    if (ind >= r || l > ind)
        return;
    if (l + 1 == r) {
        tree[v] = x;
        return;
    }
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, ind, x);
    update(2 * v + 2, m, r, ind, x);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> v(n), tmp(n);
    for (int i = 0; i < n; ++i)
        tmp[a[i] - 1] = i;
    tree.resize(4 * n, 0);
    for (int i = n - 1; i >= 0; --i) {
        v[a[i] - 1] = get(0, 0, n, 0, a[i]);
        update(0, 0, n, a[i], 1);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
        ans += v[i];
    cout << ans << " ";
    for (int _ = 0; _ < n - 2; ++_) {
        int cur;
        cin >> cur;
        --cur;
        for (int i = 0; i < tmp[cur]; ++i)
            if (a[i] > cur && v[a[i] - 1] > 0) {
                --ans;
                --v[a[i] - 1];
            }
        ans -= v[cur];
        v[cur] = 0;
        cout << ans << " ";
    }
}
