#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
const long long MXN = 5e5;
vector<long long> tree[MXN + 3];
vector<int> num[MXN + 3];
int n;
int a[MXN + 3], b[MXN + 3], cntt[MXN + 3];

int get(long long x, int v) {
    long long ans = 0LL;
    for (; x > 0; x &= (x - 1)) {
        ans += tree[v][x];
    }
    return ans;
}

void add(long long x, int cnt, int v) {
    for (; x <= tree[v].size(); x = (x | (x - 1)) + 1)
        tree[v][x] += cnt;
}


void built(int v = 0, int l = 0, int r = n) {
    cntt[v] = 0;
    if (l + 1 == r) {
        tree[v] = {0, 1};
        num[v] = {a[l]};
        return;
    }
    int m = (l + r) / 2;
    built(v + v + 1, l, m);
    built(v + v + 2, m, r);
    num[v].resize(r - l);
    merge(num[v + v + 1].begin(), num[v + v + 1].end(), num[v + v + 2].begin(), num[v + v + 2].end(), num[v].begin());
    tree[v].resize(r - l + 1);
    for (int i = 0; i < num[v].size(); ++i)
        add(i + 1, 1, v);
}

int finddpos(int x, int v) {
    int ll = -1, rr = num[v].size();
    while (ll + 1 < rr) {
        int mid = (ll + rr) / 2;
        if (num[v][mid] <= x)
            ll = mid;
        else
            rr = mid;
    }
    return rr;
}

void del(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (pos < l || r <= pos)
        return;
    if (l + 1 == r) {
        tree[v][1] = 0;
        cntt[v]++;
        return;
    }
    int m = (l + r) / 2;
    del(x, pos, v + v + 1, l, m);
    del(x, pos, v + v + 2, m, r);
    add(finddpos(x, v), -1, v);
    cntt[v]++;
}


int findans(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (l > pos)
        return 0;
    if (r <= pos + 1) {
        if(cntt[v] == num[v].size())
            return 0;
        return get(r - l, v) - get(finddpos(x, v), v);
    }
    int m = (l + r) / 2;
    return findans(x, pos, v + v + 1, l, m) + findans(x, pos, v + v + 2, m, r);
}


int findansback(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (r <= pos)
        return 0;
    if (l >= pos)
        return get(finddpos(x, v), v);
    int m = (l + r) / 2;
    return findansback(x, pos, v + v + 1, l, m) + findansback(x, pos, v + v + 2, m, r);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[a[i]] = i;
    }
    built();
    long long ans = 0LL;
    for (int i = 0; i < n; ++i)
        ans += findans(a[i], i);
    cout << ans << " ";
    for (int i = 0; i < n - 2; ++i) {
        int x;
        cin >> x;
        del(x, b[x]);
        long long k = findans(x, b[x]) + findansback(x, b[x]);
        ans -= k;
        cout << ans << " ";
    }
}