#include <iostream>
#include <vector>
#include <utility>

using namespace std;
typedef long long int63;
typedef pair<int63,int63> point;

#define fort(s,e) for(int63 i = s; i < e; i++)
#define forto(s,e) for(int63 j = s; j < e; j++)
#define fortb(s,e) for(int63 i = e - 1; i >= s; i--)
struct fenwick{
	int63 n;
	vector<int63>val;
	vector<int63>dat;
	void init(int63 x) {
		n = x;
		val = vector<int63>(n, 0);
		dat = vector<int63>(n, 0);
	}
	void add(int63 v, int63 p) {
		val[p] += v;
		int63 x = 0;
		bool good = 1;
		while ((p+1) << x <= n) {
			if (good) {
				dat[((p + 1) << x) - 1] += v;
			}
			good = ((p / 2 + 1) << (x + 1)) != ((p + 1) << x);
			p /= 2;
			x++;
		}
	}
	void upd(int63 p, int63 v) {
		add(v - val[p], p);
	}
	int63 query0(int63 e) {
		e++;
		int63 x = 0;
		int63 ans = 0;
		bool good = 1;
		while (e) {
			if (good) {
				ans += dat[(e << x) - 1];
			}
			good = (e << x) != ((e/2) << (x+1));
			e /= 2;
			x++;
		}
		return ans;
	}
};
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int63 n;
	cin >> n;
	fenwick f,f2;
	f.init(n);
	f2.init(n);
	int63 inv = 0,x;
	vector<int63>pos(n);
	vector<int63>ex(n);
	vector<bool> invs;
	vector<vector<int63>>ids(n);
	fort(0, n) {
		cin >> x;
		x--;
		/*
		int63 s = i - f.query0(x);
		inv += s;
		f.add(1,x);
		pos[x] = i;
		ex[x] = s;
		*/
		pos[i] = x;
		forto(0, i) {
			if (pos[j] > x) {
				ids[pos[j]].push_back(invs.size());
				ids[x].push_back(invs.size());
				inv++;
				invs.push_back(1);
			}
		}
	}
	fort(0, n - 2) {
		cin >> x;
		x--;
		cout << inv << ' ';
		forto(0, ids[x].size()) {
			if (invs[ids[x][j]]) {
				invs[ids[x][j]] = 0;
				inv--;
			}
		}
	}
	cout << inv << endl;
	return 0;
}