#include <iostream>
#include <vector>
#include <utility>
#include <set>
#include <algorithm>

using namespace std;
typedef long long int63;
typedef pair<int63,int63> point;

#define fort(s,e) for(int63 i = s; i < e; i++)
#define forto(s,e) for(int63 j = s; j < e; j++)
#define fortb(s,e) for(int63 i = e - 1; i >= s; i--)
struct fenwick{
	int63 n;
	vector<int63>val;
	vector<int63>dat;
	void init(int63 x) {
		n = x;
		val = vector<int63>(n, 0);
		dat = vector<int63>(n, 0);
	}
	void add(int63 v, int63 p) {
		val[p] += v;
		int63 x = 0;
		bool good = 1;
		while ((p+1) << x <= n) {
			if (good) {
				dat[((p + 1) << x) - 1] += v;
			}
			good = ((p / 2 + 1) << (x + 1)) != ((p + 1) << x);
			p /= 2;
			x++;
		}
	}
	void upd(int63 p, int63 v) {
		add(v - val[p], p);
	}
	int63 query0(int63 e) {
		e++;
		int63 x = 0;
		int63 ans = 0;
		bool good = 1;
		while (e) {
			if (good) {
				ans += dat[(e << x) - 1];
			}
			good = (e << x) != ((e/2) << (x+1));
			e /= 2;
			x++;
		}
		return ans;
	}
};
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int63 n;
	cin >> n;
	fenwick f,f1,f2;
	f.init(n);
	f1.init(n);
	f2.init(n);
	int63 inv = 0,x;
	vector<int63>pos(n);
	vector<int63>ex(n);
	vector<int63> xs;
	vector<vector<int63>>ids(n);
	fort(0, n) {
		cin >> x;
		x--;
		xs.push_back(x);
		int63 s = i - f.query0(x);
		inv += s;
		f.add(1, x);
		pos[x] = i;
		ex[x] = s;
	}
	fortb(0, n) {
		x = xs[i];
		int63 s = f1.query0(x);
		f1.add(1, x);
		ex[x] += s;
	}
	//inversion keeper:
	//f[a] = b -> g[b] = a
	set<int63>axe;
	fort(0, n - 2) {
		cin >> x;
		cout << inv << ' ';
		x--;
		inv -= ex[x];
		f2.init(n);
		int63 ci = 0;
		for (auto it = axe.begin(); it != axe.end(); it++) {
			if (*it > x) {
				break;
			}
			ci++;
			f2.add(1, pos[*it]);
		}
		axe.insert(x);
		inv += i - f2.query0(pos[x]);
		f2.add(1, pos[x]);
	}
	cout << inv << endl;
	/*
	int63 n,k;
	cin >> n >> k;
	vector<pair<int63,point>>t(n);
	vector<pair<int63, pair<set<int63>, int63>>>ops,ocp;//val,spec,rands
	ops.push_back({ 0,{{},0} });
	fort(0, n) {
		cin >> t[i].second.second >> t[i].first;
		t[i].second.first = i;
		forto(0, ops.size()) {
			if (ops[j].second.second + i - n > 0) {
				continue;
			}
			if (ops[j].second.first.find(t[i].second.first) == ops[j].second.first.end()) {
				ops[j].second.second--;
				ocp.push_back(ops[j]);
				ops[j].second.first.insert(i);
				ops[j].first += t[i].first;
				ops[j].second.second += k + 1;
				ocp.push_back(ops[j]);
				ops[j].second.second -= k;
				if (ops[j].second.first.find(t[i].second.second) == ops[j].second.first.end()) {
					ops[j].second.first.insert(t[i].second.second);
					if (t[i].second.second < i) {
						ops[j].second.second++;
					}
					ocp.push_back(ops[j]);
				}
			} else {
				ocp.push_back(ops[j]);
			}
		}
		ops = ocp;
		ocp.clear();
	}
	int63 ans = 0;
	fort(0, ops.size()) {
		if (ops[i].second.second > 0) {
			continue;
		}
		if (ops[i].first > ans) {
			ans = ops[i].first;
		}
	}
	//if A lives, A has his badge.
	//so, A can kill K randoms or a specific one.
	//choose: A wins/loses
	//if win, choose: kill specific or randoms
	//if lose, remove 1 random req.
	cout << ans << endl;
	*/
	return 0;
}