#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std;

const int N = 1e5 + 7;

namespace Aint2D {

    typedef struct Nod* Arbore;
    typedef struct Interval* Block;

    struct Nod {
        int num;
        Arbore st, dr;
        Nod() {
            num = 0, st = nullptr, dr = nullptr;
        }
    };

    struct Interval {
        Arbore eu;
        Block st, dr;
        Interval() {
            eu = new Nod;
            st = dr = nullptr;
        }
    };

    Block Radacina = new Interval;

    int x, y, n;

    void AdaugaY(Arbore root, int st = 1, int dr = n) {
        ++root->num;
        if (st == dr)
            return;
        if (root->st == nullptr && root->dr == nullptr) {
            root->st = new Nod;
            root->dr = new Nod;
        }
        int mij((st + dr)>>1);
        if (y <= mij)
            AdaugaY(root->st, st, mij);
        else
            AdaugaY(root->dr, mij + 1, dr);
    }

    void AdaugaX(Block root = Radacina, int st = 1, int dr = n) {
        if (root->eu == nullptr)
            root->eu = new Nod;
        AdaugaY(root->eu);
        if (st == dr)
            return;
        if (root->st == 0 && root->dr == 0) {
            root->st = new Interval;
            root->dr = new Interval;
        }
        int mij((st + dr)>>1);
        if (x <= mij)
            AdaugaX(root->st, st, mij);
        else
            AdaugaX(root->dr, mij + 1, dr);
    }

    int xst, xdr, yst, ydr;

    int QueryY(Arbore root, int st = 1, int dr = n) {
        if (yst <= st && dr <= ydr)
            return root->num;
        if (root->st == 0 && root->dr == 0) {
            root->st = new Nod;
            root->dr = new Nod;
        }
        int mij((st + dr)>>1), ans(0);
        if (yst <= mij)
            ans += QueryY(root->st, st, mij);
        if (ydr > mij)
            ans += QueryY(root->dr, mij + 1, dr);
        return ans;
    }

    int QueryX(Block root = Radacina, int st = 1, int dr = n) {
        if (xst <= st && dr <= xdr)
            return QueryY(root->eu);
        if (root->st == 0 && root->dr == 0) {
            root->st = new Interval;
            root->dr = new Interval;
        }
        int mij((st + dr)>>1), ans(0);
        if (xst <= mij)
            ans += QueryX(root->st, st, mij);
        if (xdr > mij)
            ans += QueryX(root->dr, mij + 1, dr);
        return ans;
    }
}

int v[N], p[N], f[N], scos[N];

int main()
{
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> v[i], p[v[i]] = i, f[i]++;
    for (int i = 1; i <= n - 2; ++i) {
        cin >> scos[i];
        f[scos[i]]--;
    }
    int a(1e9 + 7), b(-1);
    for (int i = 1; i <= n; ++i)
        if (f[i])
            a = min(a, i), b = max(b, i);
    assert(a <= n && b >= 1 && a != b);
    vector < int > ans(0);
    int inv(0);
    if (p[a] > p[b])
        inv++;
    ans.push_back(inv);
    Aint2D::n = n;
    auto baga = [](int x, int y) {
        Aint2D::x = x;
        Aint2D::y = y;
        Aint2D::AdaugaX();
    };
    auto scoate = [&n](int x, int y) -> int {
        int ans(0);
        Aint2D::xst = x + 1;    ///val mai mare si plasat inainte
        Aint2D::xdr = n;
        Aint2D::yst = 1;
        Aint2D::ydr = y - 1;
        ans += Aint2D::QueryX();
        Aint2D::xst = 1;        ///val mai mica si plasat dupa
        Aint2D::xdr = x - 1;
        Aint2D::yst = y + 1;
        Aint2D::ydr = n;
        ans += Aint2D::QueryX();
        return ans;
    };
    baga(a, p[a]);
    baga(b, p[b]);
    for (int i = n - 2; i >= 1; --i) {
        inv += scoate(scos[i], p[scos[i]]);
        baga(scos[i], p[scos[i]]);
        ans.push_back(inv);
    }
    reverse(ans.begin(), ans.end());
    for (int i : ans)
        cout << i << ' ';
    return 0;
}
