#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

vector<vector<int>> sorted(475);

const int k = 5000;
const int maxn = 100000;

vector<int> f(maxn, 0);

int get(int i) {
    int ans = 0;
    while(i >= 0) {
        ans += f[i];
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

void upd(int i, int val) {
    while(i < maxn) {
        f[i] += val;
        i = (i | (i + 1));
    }
}


int get(int l, int r) {
    if (l == 0) {
        return get(r);
    }
    return get(r) - get(l - 1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    int m = n - 2;
    vector<int> ord(m);
    for (int &i : ord) {
        cin >> i;
    }
    vector<int> pos(n + 1);
    for(int i = 0; i < n; ++i) {
        pos[a[i]] = i;
    }
    for(int i = 0; i < n; ++i) {
        sorted[i / k].push_back(a[i]);
    }
    for(int i = 0; i < sorted.size(); ++i) {
        sort(sorted[i].begin(), sorted[i].end());
    }
    long long ans = 0;
    for(int i = 0; i < n; ++i) {
        ans += get(a[i], n - 1);
        upd(a[i] - 1, 1);
    }
    cout << ans << ' ';
    vector<bool> ok(n, true);
    for(int i : ord) {
        int j = pos[i];
        //delta
        ok[j] = false;
        long long d = 0;
        int block = j/ k;
        for(int l = block * k; l < j; ++l) {
            if (a[l] > i && ok[l]) {
                ++d;
            }
        }
        for(int l = j + 1; l < n && l < (block + 1) * k; ++l) {
            if (a[l] < i && ok[l]) {
                ++d;
            }
        }
        for(int j = 0; j < block; ++j) {
            d += sorted[j].size() - (upper_bound(sorted[j].begin(), sorted[j].end(), i) - sorted[j].begin());
        }
        for(int j = block + 1; j < sorted.size(); ++j) {
            d += lower_bound(sorted[j].begin(), sorted[j].end(), i) - sorted[j].begin();
        }
        ans -= d;
        //delete
        int idx = lower_bound(sorted[j / k].begin(), sorted[j / k].end(), i) - sorted[j / k].begin();
        sorted[j / k].erase(sorted[j / k].begin() + idx);
        cout << ans << ' ';
    }
    return 0;
}