#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cmath>
#define int long long
using namespace std;

struct segtree_sum{
    vector<int> tree;
    int size = 1;
    void init(int n){
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
    }
    void set(int i, int v, int x, int lx, int rx){
        if (rx - lx == 1){
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m)
            set(i, v, 2 * x + 1, lx, m);
        else
            set(i, v, 2 * x + 2, m, rx);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }
    void set(int i, int v){
        set(i, v, 0, 0, size);
    }
    int sum(int l, int r, int x, int lx, int rx){
        if (r <= lx || rx <= l)
            return 0;
        if (l <= lx && rx <= r)
            return tree[x];
        int m = (lx + rx) / 2;
        return sum(l, r, 2 * x + 1, lx, m) + sum(l, r, 2 * x + 2, m, rx);
    }
    int sum(int l, int r){
        return sum(l, r, 0, 0, size);
    }
};
signed main() {
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> p(n);
    vector<int> place(n);
    segtree_sum a;
    a.init(n);
    vector<int> ans(n, 0);
    vector<bool> alive(n, true);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
        place[p[i] - 1] = i;
    }
    vector<int> inv(n);
    for (int i = 0; i < n; i++) {
        inv[p[i] - 1] = a.sum(p[i], n);
        a.set(p[i] - 1, 1);
        ans[0] += inv[p[i] - 1];
    }
    int sum = ans[0];
    for (int i = 0; i < n - 2; i++){
        int q;
        cin >> q;
        alive[q - 1] = false;
        for (int j = place[q - 1] + 1; j < n; j++){
            if (p[j] < q && alive[p[j] - 1]) {
                inv[p[j] - 1]--;
                sum--;
            }
        }
        sum -= inv[q - 1];
        ans[i + 1] = sum;
    }
    for (int i = 0; i < n - 1; i++)
        cout << ans[i] << ' ';
}