#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include "map"
using namespace std;
struct segtree1{
    int size;
    vector<int> tree;
    vector<int> add;
    vector<pair<int, int>> elems;
    void elemsassign(vector<int> e){
        elems.assign(e.size(), {0, 0});
        for (int i = 0; i < e.size(); ++i) {
            elems[i] = {e[i], i + 1};
        }
        elems.push_back({-1000, 0});
        elems.push_back({1e7, e.size() + 1});
        sort(elems.begin(), elems.end());
    }
    void make(int s){
        size = 1;
        while(size <= s + 3)
            size *= 2;
        tree.assign(2 * size, 0);
        add.assign(2 * size, 0);
    }
    void push(int v){
        add[v * 2] += add[v];
        add[v * 2 + 1] += add[v];
        add[v] = 0;
    }
    int get(int v){
        return add[v] + tree[v];
    }
    //void pull(int v){
    //    tree[v] = get(v * 2 + 1) + get(v * 2);
    //}
    void add2(int l, int r, int ll, int rr, int v){
        if(l <= ll and rr <= r){
            add[v] += 1;
            return;
        }
        if(r <= ll or l >= rr){
            return;
        }
        push(v);
        int m = (ll + rr) / 2;
        add2(l, r, ll, m, v * 2);
        add2(l, r, m, rr, v * 2 + 1);
        //pull(v);
    }
    int segget2(int p, int l, int r, int v){
        if(p == l and r == p + 1)
            return get(v);
        if(p + 1 <= l or p >= r){
            return 0;
        }
        push(v);
        int m = (l + r) / 2;
        int res = segget2(p, l, m, v * 2) + segget2(p, m, r, v * 2 + 1);
        //pull(v);
        return res;
    }
    int segget(int p){
        return segget2(p, 0, size, 1);
    }
    void segadd(int l, int r){
        add2(l, r, 0, size, 1);
    }
    void addless(int v){
        int p = upper_bound(elems.begin(), elems.end(), pair<int, int>{v, 1e7}) - elems.begin();
        segadd(0, p);
    }
    int seeless(int v){
        int p = upper_bound(elems.begin(), elems.end(), pair<int, int>{v, 1e7}) - elems.begin();
        return segget(p);
    }
    void addgre(int v){
        int p = upper_bound(elems.begin(), elems.end(), pair<int, int>{v, 1e7}) - elems.begin();
        segadd(p, size);
    }
    int seegre(int v){
        int p = lower_bound(elems.begin(), elems.end(), pair<int, int>{v, -1}) - elems.begin();
        return segget(p);
    }
};
void f1(){
    segtree1 st;
    st.make(8);
    st.segadd(0, 5);
    for (int i = 0; i < 8; ++i) {
        cout << st.segget(i) << ' ';
    }
    cout << endl;
    st.segadd(0, 6);
    for (int i = 0; i < 8; ++i) {
        cout << st.segget(i) << ' ';
    }
    cout << endl;
    st.segadd(0, 7);
    for (int i = 0; i < 8; ++i) {
        cout << st.segget(i) << ' ';
    }
}
void f2(){
    segtree1 st;
    st.make(8);
    st.elemsassign({1, 5, 7, 11, 15, 20, 40, 80});
    while(true){
        int a, b;
        cin >> a >> b;
        if(a == 1)
            st.addgre(b);
        else
            cout << st.seegre(b) << endl;
    }
}
struct intree{
    int size;
    segtree1 stless, stgre;
    void make(vector<int> elems, int n){
        stless.make(n);
        stgre.make(n);
        stgre.elemsassign(elems);
        stless.elemsassign(elems);
    }
    int seeless(int v){
        return stless.seeless(v);
    }
    void add(int v){
        stgre.addgre(v);
        stless.addless(v);
    }
    int seegre(int v){
        return stgre.seegre(v);
    }
};
struct segtree{
    int size;
    vector<intree> tree;
    void make(vector<int> k){
        size = 1;
        while(size < k.size()){
            size *= 2;
        }
        tree.assign(size * 2, {});
        vector<vector<int>> helpv(size * 2, vector<int>());
        for (int i = 0; i < k.size(); ++i) {
            helpv[i + size] = {k[i]};
        }
        for (int i = size - 1; i > 0; --i) {
            for(auto t : helpv[i * 2])
                helpv[i].push_back(t);
            for(auto t : helpv[i * 2 + 1])
                helpv[i].push_back(t);
        }
        for (int i = 1; i < tree.size(); ++i) {
            tree[i].make(helpv[i], helpv[i].size());
        }
    }
    int less(int l, int r, int x){
        l = size + l;
        r = size + r;
        int res = 0;
        while(l < r){
            if(l&1){
                //cout << "L " << l << ' ' << tree[l].seeless(x) << endl;
                res += tree[l].seeless(x);
                l++;
            }
            if(not (bool(r&1))){
                //cout << "R " << r << ' ' << tree[r].seeless(x) << endl;
                res += tree[r].seeless(x);
                r--;
            }
            l /= 2;
            r /= 2;
        }
        if(r == l){
            //cout << "LR " << l << ' ' << tree[l].seeless(x) << endl;
            res += tree[r].seeless(x);
        }
        return res;
    }
    int gre(int l, int r, int x){
        l = size + l;
        r = size + r;
        int res = 0;
        while(l < r){
            if(l&1){
                //if(x == 5) cout << "L" << l << ' ' << tree[l].seegre(x) << ", ";
                res += tree[l].seegre(x);
                l++;
            }
            if(not (bool(r&1))){
                //if(x == 5) cout << "R" << r << ' ' << tree[r].seegre(x) << ", ";
                res += tree[r].seegre(x);
                r--;
            }
            l /= 2;
            r /= 2;
        }
        if(r == l){
            //if(x == 5) cout << "LR" << r << ' ' << tree[r].seegre(x) << ", ";
            res += tree[r].seegre(x);
        }
       //cout << endl;
        return res;
    }
    void change(int p, int x){
        int pos = p + size;
        while(pos){
            tree[pos].add(x);
            pos /= 2;
        }
    }
    int turn(int p, int x){
        change(p, x);
        //cout << less(0, p, x) << ' ' << gre(p, size - 1, x) << endl;
        return less(0, p, x) + gre(p, size - 1, x);
    }
};
int main() {
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    map<int, int> mp;
    int n;
    cin >> n;
    vector<int> lst(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> lst[i];
        mp[lst[i]] = i;
    }
    segtree st;
    st.make(lst);
    vector<int> ddd(n, 0);
    vector<bool> alive(n, true);
    for (int i = 0; i < n - 2; ++i) {
        int a;
        cin >> a;
        alive[a-1] = false;
        ddd[i] = a;
    }
    int k = n - 2;
    for (int i = 0; i < n; ++i) {
        if(alive[i]){
            ddd[k] = i + 1;
            k += 1;
        }
    }
    vector<long long> ans(n, 0);
    reverse(ddd.begin(), ddd.end());
    for (int i = 0; i < n; ++i) {
        int p = mp[ddd[i]];
        int x = ddd[i];
        //cout << x << " !! " << p << endl;
        if(i >= 1)
            ans[i] = ans[i-1];
        ans[i] += st.turn(p, x);
    }
    for (int i = n - 1; i >= 1; --i) {
        cout << ans[i] << ' ';
    }
}