#include <iostream>
#include <algorithm>
#include <vector>
#define int long long
#pragma GCC Optimize("Ofast")

using namespace std;

const int k = 120;
vector < vector <int> > b(k, vector <int> ());
vector <int> len(k);
vector < vector <int> > p(k, vector <int> ());
vector < vector <int> > s(k, vector <int> ());
vector <int> a;

int get_min(int l, int r, int x) {
    if (r - l + 1 <= k) {
        int res = 0;
        for (int i = l; i <= r; ++i) {
            if (a[i] != 0 && a[i] < x) {
                res++;
            }
        }
        return res;
    }
    int res = 0;
    while (l % k != 0) {
        if (a[l] != 0 && a[l] < x) {
            res++;
        }
        l++;
    }
    while (r % k != k - 1) {
        if (a[r] != 0 && a[r] < x) {
            res++;
        }
        l--;
    }
    while (l < r) {
        int seg = upper_bound(b[l / k].begin(), b[l / k].end(), x - 1) - b[l / k].begin();
        res += p[l / k][seg];
        l += k;
    }
    return res;
}

int get_max(int l, int r, int x) {
    if (r - l + 1 <= 2 * k) {
        int res = 0;
        for (int i = l; i <= r; ++i) {
            if (a[i] > x) {
                res++;
            }
        }
        return res;
    }
    int res = 0;
    while (l % k != 0) {
        if (a[l] > x) {
            res++;
        }
        l++;
    }
    while (r % k != k - 1) {
        if (a[r] > x) {
            res++;
        }
        l--;
    }
    while (l < r) {
        int seg = lower_bound(b[l / k].begin(), b[l / k].end(), x + 1) - b[l / k].begin();
        res += s[l / k][seg];
        l += k;
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    a.resize(n);
    vector <int> num(n);
    int l = (n - 1)/ k + 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i / k].push_back(a[i]);
        num[a[i] - 1] = i;
    }
    for (int i = 0; i < l; ++i) {
        sort(b[i].begin(), b[i].end());
        len[i] = b[i].size();
        p[i].resize(len[i] + 1);
        s[i].resize(len[i] + 1);
        p[i][0] = 0;
        for (int j = 1; j <= len[i]; ++j) {
            p[i][j] = p[i][j - 1] + 1;
        }
        s[i][len[i]] = 0;
        for (int j = len[i] - 1; j >= 0; --j) {
            s[i][j] = s[i][j + 1] + 1;
        }
    }
    int an = 0;
    for (int i = 0; i < n; ++i) {
        an += get_max(0, i - 1, a[i]);
        an += get_min(i + 1, n - 1, a[i]);
    }
    an /= 2;
    cout << an << " ";
    for (int q = 0; q < n - 2; ++q) {
        int d; cin >> d;
        int ind = num[d - 1];
        an -= get_max(0, ind - 1, d);
        an -= get_min(ind + 1, n - 1, d);
        cout << an << " ";
        bool was = 0;
        for (int i = 1; i <= len[ind / k]; ++i) {
            if (b[ind / k][i - 1] == d) {
                was = 1;
            }
            if (was) {
                p[ind / k][i]--;
            }
        }
        was = 0;
        for (int i = len[ind / k] - 1; i >= 0; --i) {
            if (b[ind / k][i] == d) {
                was = 1;
            }
            if (was) {
                s[ind / k][i]--;
            }
        }
        a[ind] = 0;
    }
    return 0;
}
