#include <iostream>
#include <vector>
#include <algorithm>
#include <time.h>
using namespace std;

struct nodee {
	int x, y;
	int val;
	int size = 1;
	nodee* l = NULL, * r = NULL;
	nodee(int x, int val) {
		this->x = x;
		this->val = val;
		y = rand();
	}

};
int gs(nodee* root) {
	if (root) {
		return root->size;
	}
	return 0;
}
void update(nodee* root) {
	if (!root)
		return;
	int sz = 1;
	sz += gs(root->l);
	sz += gs(root->r);
	root->size = sz;
}
pair<nodee*, nodee*> split(nodee* root, int x) {
	if (root == NULL) {
		return { NULL,NULL };
	}
	if (x <= root->x) {
		auto t = split(root->l, x);
		root->l = t.second;
		update(root);
		return { t.first,root };
	}
	else {
		auto t = split(root->r, x);
		root->r = t.first;
		update(root);
		return { root,t.second };
	}
}
nodee* merge(nodee* l, nodee* r) {
	if (l == NULL) {
		return r;
	}
	if (r == NULL) {
		return l;

	}
	if (l->y > r->y) {
		l->r = merge(l->r, r);
		update(l);
		return l;
	}
	else {
		r->l = merge(l, r->l);
		update(r);
		return r;
	}

}
int getnum(nodee* root, int num) {
	auto t = split(root, num);
	int aans = gs(t.first);
	root = merge(t.first, t.second);
	return aans;
}

nodee* dell(nodee* root, int val) {
	auto t = split(root, val);
	auto tt = split(t.second, val + 1);
	return merge(t.first, tt.second);
}
nodee* add(nodee* root, int val) {
	auto t = split(root, val);
	
	return merge(t.first, merge(new nodee(val, val), t.second));;
}


vector<int> a;
vector<int> addpos;
vector<int> anses;
void mergesort1(int l, int r) {
	if (r - l < 1) {
		return;
	}
	int m = (r + l) / 2;
	mergesort1(l, m);
	mergesort1(m + 1, r);
	int lpos = l, rpos = m + 1;
	vector<int> aa(r - l + 1);
	int cur = 0;
	nodee* root = NULL;
	for (int i = l; i <=m; i++) {
		root = add(root, addpos[a[i]]);

	}
	while (lpos != m + 1 || rpos != r + 1) {
		if (lpos == m + 1) {
			aa[cur] = a[rpos];
			
			cur++;
			rpos++;
		}
		else if (rpos == r + 1) {
			aa[cur] = a[lpos];
			root = dell(root, addpos[a[lpos]]);
			cur++;
			lpos++;
			
		}
		else if (a[lpos] < a[rpos]) {
			aa[cur] = a[lpos];
			root = dell(root, addpos[a[lpos]]);
			cur++;
			lpos++;
		}
		else {

			aa[cur] = a[rpos];
			/*for (int i = lpos; i <= m; i++) {
				if (addpos[a[i]] > addpos[a[rpos]]) {
					anses[a[i]]++;
				}
				else {
					anses[a[rpos]]++;
				}
			}*/
			anses[a[rpos]] += getnum(root, addpos[a[rpos]]);
			cur++;
			rpos++;
			
		}

	}
	for (int i = 0; i < r - l + 1; i++) {
		a[l + i] = aa[i];
	}
	return;
}

void mergesort2(int l, int r) {
	if (r - l < 1) {
		return;
	}
	int m = (r + l) / 2;
	mergesort2(l, m);
	mergesort2(m + 1, r);
	int lpos = l, rpos = m + 1;
	vector<int> aa(r - l + 1);
	int cur = 0;
	nodee* root = NULL;
	
	while (lpos != m + 1 || rpos != r + 1) {
		if (lpos == m + 1) {
			aa[cur] = a[rpos];
			root = add(root, addpos[a[rpos]]);
			cur++;
			rpos++;
		}
		else if (rpos == r + 1) {
			aa[cur] = a[lpos];
			anses[a[lpos]] += getnum(root, addpos[a[lpos]]);
			cur++;
			lpos++;

		}
		else if (a[lpos] < a[rpos]) {
			aa[cur] = a[lpos];
			anses[a[lpos]] += getnum(root, addpos[a[lpos]]);
			cur++;
			lpos++;
		}
		else {

			aa[cur] = a[rpos];
			root=add(root, addpos[a[rpos]]);
			cur++;
			rpos++;

		}

	}
	for (int i = 0; i < r - l + 1; i++) {
		a[l + i] = aa[i];
	}
	return;
}





int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	srand(time(NULL));
	int n;
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	anses.resize(n);
	addpos.resize(n);
	vector<int> del(n, 0);
	vector<int> dord;
	for (int i = 0; i < n-2; i++) {
		int aa;
		cin >> aa;
		aa--;
		dord.push_back(aa);
		addpos[aa] = n - 1 - i;
		del[aa] = 1;
	}
	int cp = 1;
	
	for (int i = 0; i < n; i++) {
		if (!del[i]) {
			addpos[i] = cp--;
			dord.push_back(i);
		}
	}
	reverse(dord.begin(), dord.end());

	vector<int> b(a);
	mergesort1(0, n - 1);
	a = b;
	mergesort2(0, n - 1);
	int ans = 0;
	ans = anses[dord[0]] + anses[dord[1]];
	vector<int> finalans;
	finalans.push_back(ans);
	for (int i = 2; i < n; i++) {
		ans += anses[dord[i]];
		finalans.push_back(ans);
	}
	reverse(finalans.begin(), finalans.end());
	for (auto h : finalans) {
		cout << h << ' ';
	}

}