#include <iostream>
#include <vector>
#include <algorithm>
#include <time.h>
using namespace std;

struct nodee {
	long long x, y;
	long long val;
	long long size = 1;
	nodee* l = NULL, * r = NULL;
	nodee(long long x, long long val) {
		this->x = x;
		this->val = val;
		y = (rand()*(1<<14)+rand());
	}

};
long long gs(nodee* root) {
	if (root) {
		return root->size;
	}
	return 0;
}
void update(nodee* root) {
	if (!root)
		return;
	long long sz = 1;
	sz += gs(root->l);
	sz += gs(root->r);
	root->size = sz;
}
pair<nodee*, nodee*> split(nodee* root, long long x) {
	if (root == NULL) {
		return { NULL,NULL };
	}
	if (x <= root->x) {
		auto t = split(root->l, x);
		root->l = t.second;
		update(root);
		return { t.first,root };
	}
	else {
		auto t = split(root->r, x);
		root->r = t.first;
		update(root);
		return { root,t.second };
	}
}
nodee* merge(nodee* l, nodee* r) {
	if (l == NULL) {
		return r;
	}
	if (r == NULL) {
		return l;

	}
	if (l->y > r->y) {
		l->r = merge(l->r, r);
		update(l);
		return l;
	}
	else {
		r->l = merge(l, r->l);
		update(r);
		return r;
	}

}
long long getnum(nodee* root, long long num) {
	auto t = split(root, num);
	long long aans = gs(t.first);
	root = merge(t.first, t.second);
	return aans;
}

nodee* dell(nodee* root, long long val) {
	auto t = split(root, val);
	auto tt = split(t.second, val + 1);
	return merge(t.first, tt.second);
}

nodee* add(nodee* root, nodee* nn) {
	/*auto t = split(root, val);
	
	return merge(t.first, merge(new nodee(val, val), t.second));;*/
	
	if (!root) {
		return nn;

	}
	
	if (root->y > nn->y) {
		if (nn->x < root->x) {
			root->l = add(root->l, nn);
			update(root);
			return root;
		}
		else {
			root->r = add(root->r, nn);
			update(root);
			return root;
		}
	}
	else {
		auto tt = split(root, nn->x);
		nn->l = tt.first;
		nn->r = tt.second;
		update(nn);
		return nn;
	}
	
}


vector<long long> a;
vector<long long> addpos;
vector<long long> anses;
void mergesort1(long long l, long long r) {
	if (r - l < 1) {
		return;
	}
	long long m = (r + l) / 2;
	mergesort1(l, m);
	mergesort1(m + 1, r);
	long long lpos = l, rpos = m + 1;
	vector<long long> aa(r - l + 1);
	long long cur = 0;
	nodee* root = NULL;
	for (long long i = l; i <=m; i++) {
		root = add(root, new nodee(addpos[a[i]],addpos[a[i]]));

	}
	while (lpos != m + 1 || rpos != r + 1) {
		if (lpos == m + 1) {
			aa[cur] = a[rpos];
			
			cur++;
			rpos++;
		}
		else if (rpos == r + 1) {
			aa[cur] = a[lpos];
			root = dell(root, addpos[a[lpos]]);
			cur++;
			lpos++;
			
		}
		else if (a[lpos] < a[rpos]) {
			aa[cur] = a[lpos];
			root = dell(root, addpos[a[lpos]]);
			cur++;
			lpos++;
		}
		else {

			aa[cur] = a[rpos];
			/*for (long long i = lpos; i <= m; i++) {
				if (addpos[a[i]] > addpos[a[rpos]]) {
					anses[a[i]]++;
				}
				else {
					anses[a[rpos]]++;
				}
			}*/
			anses[a[rpos]] += getnum(root, addpos[a[rpos]]);
			cur++;
			rpos++;
			
		}

	}
	for (long long i = 0; i < r - l + 1; i++) {
		a[l + i] = aa[i];
	}
	return;
}

void mergesort2(long long l, long long r) {
	if (r - l < 1) {
		return;
	}
	long long m = (r + l) / 2;
	mergesort2(l, m);
	mergesort2(m + 1, r);
	long long lpos = l, rpos = m + 1;
	vector<long long> aa(r - l + 1);
	long long cur = 0;
	nodee* root = NULL;
	
	while (lpos != m + 1 || rpos != r + 1) {
		if (lpos == m + 1) {
			aa[cur] = a[rpos];
			root = add(root, new nodee(addpos[a[rpos]],addpos[a[rpos]]));
			cur++;
			rpos++;
		}
		else if (rpos == r + 1) {
			aa[cur] = a[lpos];
			anses[a[lpos]] += getnum(root, addpos[a[lpos]]);
			cur++;
			lpos++;

		}
		else if (a[lpos] < a[rpos]) {
			aa[cur] = a[lpos];
			anses[a[lpos]] += getnum(root, addpos[a[lpos]]);
			cur++;
			lpos++;
		}
		else {

			aa[cur] = a[rpos];
			root=add(root, new nodee (addpos[a[rpos]],addpos[a[rpos]]));
			cur++;
			rpos++;

		}

	}
	for (long long i = 0; i < r - l + 1; i++) {
		a[l + i] = aa[i];
	}
	return;
}





int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	srand(time(NULL));
	long long n;
	cin >> n;
	a.resize(n);
	for (long long i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	anses.resize(n);
	addpos.resize(n);
	vector<long long> del(n, 0);
	vector<long long> dord;
	for (long long i = 0; i < n-2; i++) {
		long long aa;
		cin >> aa;
		aa--;
		dord.push_back(aa);
		addpos[aa] = n - 1 - i;
		del[aa] = 1;
	}
	long long cp = 1;
	
	for (long long i = 0; i < n; i++) {
		if (!del[i]) {
			addpos[i] = cp--;
			dord.push_back(i);
		}
	}
	reverse(dord.begin(), dord.end());

	vector<long long> b(a);
	mergesort1(0, n - 1);
	a = b;
	mergesort2(0, n - 1);
	long long ans = 0;
	ans = anses[dord[0]] + anses[dord[1]];
	vector<long long> finalans;
	finalans.push_back(ans);
	for (long long i = 2; i < n; i++) {
		ans += anses[dord[i]];
		finalans.push_back(ans);
	}
	reverse(finalans.begin(), finalans.end());
	for (auto h : finalans) {
		cout << h << ' ';
	}

}