#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define ll long long
#define ull unsigned long long
#define pb push_back
#define F first
#define S second

using namespace std;
using namespace __gnu_pbds;

struct segtree {

    vector <int> t;
    int sz;

    segtree (int n) {
        sz = 1;
        while(sz < n) sz *= 2;
        t.resize(sz * 4);
    }

    void upd(int v, int tl, int tr, int pos) {
        if(tl > pos || tr < pos) return;
        if(tl == tr && tl == pos) {
            t[v] = 1;
            return;
        }
        int mid = (tl + tr) >> 1;
        if(pos <= mid) upd(v * 2, tl, mid, pos);
        else upd(v * 2 + 1, mid + 1, tr, pos);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }

    void upd(int pos) {
        upd(1, 0, sz - 1, pos);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if(tl > r || tr < l) return 0;
        if(tl >= l && tr <= r) {
            return t[v];
        }
        int mid = (tl + tr) >> 1;
        return get(v * 2, tl, mid, l, r) + get(v * 2 + 1, mid + 1, tr, l, r);
    }

    int get(int l, int r) {
        return get(1, 0, sz - 1, l, r);
    }

};

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int n;
    cin >> n;
    int a[n];
    int pos[n];
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i] --;
        pos[a[i]] = i;
    }
    segtree t(n);
    vector <int> p(n, 0);
    for(int i = 0; i < n; ++i) {
        p[i] = t.get(a[i] + 1, n - 1);
        t.upd(a[i]);
    }
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        ans += p[i];
    }
    int z[n - 2];
    for(int i = 0; i < n - 2; ++i) {
        cin >> z[i];
        z[i] --;
    }
    cout << ans << ' ';
    vector <bool> used(n);
    for(int i = 0; i < n - 2; ++i) {
        int x = pos[z[i]];
        ans -= p[x];
//        cout << p[x] << endl;
        used[x] = 1;
        for(int j = x + 1; j < n; ++j) {
            if(!used[j] && a[j] < z[i]) {
//                cout << z[i] << ' ' << a[j] << endl;
                p[j] --;
                ans --;
            }
        }
        cout << ans << ' ';
    }
}
