#include <bits/stdc++.h>
//#define int long long
#define f first
#define s second
#define pb push_back
#pragma optimize(O3)
using namespace std;
struct node {
    int x, y, sz;
    node *l, *r;
    node(int _x) {
        x = _x;
        y = rand();
        sz = 1;
        l = nullptr;
        r = nullptr;
    }
};
int size(node* root) {
    if (root == nullptr)
        return 0;
    return root->sz;
}
void relax(node *root) {
    root->sz = size(root->l)+size(root->r)+1;
}
node* merge(node *root1, node *root2) {
    if (root1 == nullptr)
        return root2;
    if (root2 == nullptr)
        return root1;
    if (root1->y > root2->y) {
        auto res = merge(root1->r, root2);
        root1->r = res;
        relax(root1);
        return root1;
    }
    auto res = merge(root1, root2->l);
    root2->l = res;
    relax(root2);
    return root2;
}
pair<node*, node*> split(node* root, int val) {
    if (root == nullptr)
        return {nullptr, nullptr};
    if (root->x <= val) {
        auto [res1, res2] = split(root->r, val);
        root->r = res1;
        relax(root);
        return {root, res2};
    }
    auto [res1, res2] = split(root->l, val);
    root->l = res2;
    relax(root);
    return {res1, root};
}
node* insert(node *root, int x) {
    auto [res1, res2] = split(root, x);
    auto res3 = new node(x);
    return merge(merge(res1, res3), res2);
}
node *erase(node *root, int x) {
    auto [res1, res2] = split(root, x);
    auto [res3, res4] = split(res1, x-1);
    return merge(res3, res2);
}
int get2(node *root, int x) {
    if (root == nullptr)
        return 0;
    if (root->x <= x)
        return size(root->l)+1+get2(root->r, x);
    else
        return get2(root->l, x);
}
const int maxn = 100000;
node *t[maxn];
void build() {
    for (int i = 0; i < maxn; ++i)
        t[i] = nullptr;
}
void add(int pos, int val) {
    for (int i = pos; i < maxn; i = (i|(i+1)))
        t[i] = insert(t[i], val);
}
void add2(int pos, int val) {
    for (int i = pos; i < maxn; i = (i|(i+1)))
        t[i] = erase(t[i], val);
}
int get(int ql, int qr, int t2, int x) {
    int ans = 0;
    for (int i = qr; i >= 0; i = (i&(i+1))-1) {
        if (t2 == 0) {
            ans += get2(t[i], x-1);
        } else {
            ans += size(t[i])-get2(t[i], x);
        }
    }
    for (int i = ql-1; i >= 0; i = (i&(i+1))-1) {
        if (t2 == 0) {
            ans -= get2(t[i], x-1);
        } else {
            ans -= size(t[i])-get2(t[i], x);
        }
    }
    return ans;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> pos(n);
    long long ans = 0;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        x--;
        pos[x] = i;
        ans = ans+get(0, i, 1, x);
        add(i, x);
        //cout << ans << '\n';
    }
    cout << ans << ' ';
    for (int i = 0; i+2 < n; ++i) {
        int x;
        cin >> x;
        x--;
        int p = pos[x];
        ans = ans-get(0, p, 1, x);
        ans = ans-get(p+1, n-1, 0, x);
        add2(p, x);
        cout << ans << ' ';
    }
    return 0;
}
