#include <bits/stdc++.h>
//#define int long long
#define f first
#define s second
#define pb push_back
#define all(a) a.begin(), a.end()
using namespace std;
struct node {
    int x, y, sz;
    node *l, *r;
    node(int _x) {
        x = _x;
        y = rand();
        sz = 1;
        l = nullptr;
        r = nullptr;
    }
};
int size(node* root) {
    if (root == nullptr)
        return 0;
    return root->sz;
}
void relax(node *root) {
    root->sz = size(root->l)+size(root->r)+1;
}
node* merge(node *root1, node *root2) {
    if (root1 == nullptr)
        return root2;
    if (root2 == nullptr)
        return root1;
    if (root1->y > root2->y) {
        auto res = merge(root1->r, root2);
        root1->r = res;
        relax(root1);
        return root1;
    }
    auto res = merge(root1, root2->l);
    root2->l = res;
    relax(root2);
    return root2;
}
pair<node*, node*> split(node* root, int val) {
    if (root == nullptr)
        return {nullptr, nullptr};
    if (root->x <= val) {
        auto [res1, res2] = split(root->r, val);
        root->r = res1;
        relax(root);
        return {root, res2};
    }
    auto [res1, res2] = split(root->l, val);
    root->l = res2;
    relax(root);
    return {res1, root};
}
node* insert(node *root, int x) {
    auto [res1, res2] = split(root, x);
    auto res3 = new node(x);
    return merge(merge(res1, res3), res2);
}
int get2(node *root, int x) {
    if (root == nullptr)
        return 0;
    if (root->x <= x)
        return size(root->l)+1+get2(root->r, x);
    else
        return get2(root->l, x);
}
const int maxn = 100000;
node *t[maxn];
void build() {
    for (int i = 0; i < maxn; ++i)
        t[i] = nullptr;
}
void add(int pos, int val) {
    for (int i = pos; i < maxn; i = (i|(i+1)))
        t[i] = insert(t[i], val);
}
int get(int ql, int qr, int t2, int x) {
    int ans = 0;
    for (int i = qr; i >= 0; i = (i&(i+1))-1) {
        if (t2 == 0) {
            ans += get2(t[i], x-1);
        } else {
            ans += size(t[i])-get2(t[i], x);
        }
    }
    for (int i = ql-1; i >= 0; i = (i&(i+1))-1) {
        if (t2 == 0) {
            ans -= get2(t[i], x-1);
        } else {
            ans -= size(t[i])-get2(t[i], x);
        }
    }
    return ans;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        x--;
        pos[x] = i;
    }
    vector<long long> ans(n-1);
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        a[pos[i]] = i;
    vector<int> q(n-2);
    for (int i = 0; i < n-2; ++i) {
        cin >> q[i], q[i]--;
        a[pos[q[i]]] = -1;
    }
    reverse(all(q));
    for (int i = 0; i < n; ++i) {
        if (a[i] != -1) {
            ans[0] += get(0, i, 1, a[i]);
            ans[0] += get(i+1, n-1, 0, a[i]);
            add(i, a[i]);
        }
    }
    for (int i = 0; i < n-2; ++i) {
        ans[i+1] = ans[i];
        ans[i+1] += get(0, pos[q[i]], 1, q[i]);
        ans[i+1] += get(pos[q[i]]+1, n-1, 0, q[i]);
        add(pos[q[i]], q[i]);
    }
    reverse(all(ans));
    for (int i = 0; i+1 < n; ++i)
        cout << ans[i] << ' ';
    return 0;
}
