//
//  main.cpp
//  D
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <random>
#include <algorithm>
#include <vector>

#define int long long

using namespace std;
int sol1(int n, int k, vector<int> t, vector<int> l) {
    // vector<int> sol = {1, 4, 6};
    int maxx = 0;
    for (int i = 0; i < (2<<n); i++) {
        vector<int> took;
        for (int j = 0; j < n; j++) {
            if (i>>j&1) {
                took.push_back(j);
            }
        }
        int rest = n - took.size();
        int summ = 0;
        for (auto j : took) {
            if (i>>t[j]&1) {
                rest -= k;
            }
            else {
                rest -= 1;
            }
            summ += l[j];
        }
        
        if (rest >= 0) {
            maxx = max(maxx, summ);
        }
    }
    return maxx;
}


vector<int> count_dp(vector<int> l, int n, int k) {
    vector<vector<pair<int, int>>> dp(2, vector<pair<int, int>> (n + 1, {-1e9, -1e9}));
    dp[1][1].first = l[0];
    for (int i = 2; i <= l.size(); i++) {
        dp[0] = dp[1];
        for (int j = 0; j <= n; j++) {
            if (j >= k) {
                if (j < n && j != 0) {
                    dp[1][j + 1].first = max(dp[0][j - 1].second, dp[0][j - k].first) + l[i - 1];
                }
                dp[1][j].second = max(dp[0][j].second, dp[0][j].first);
            }
            else {
                if (j < n && j != 0) {
                    dp[1][j + 1].first = dp[0][j - 1].second + l[i - 1];
                    
                }
                dp[1][j].second = max(dp[0][j].second, dp[0][j].first);
            }
        }
    }
    
    vector<int> ans(n + 1);
    for (int i = 0; i <= n - 1; i++) {
        ans[i + 1] = max(ans[i + 1], dp.back()[i].second);
    }
    for (int i = 0; i <= n - k; i++) {
        ans[i + k] = max(ans[i + k], dp.back()[i].first);
    }
    
    dp = vector<vector<pair<int, int>>> (2, vector<pair<int, int>> (n + 1, {-1e9, -1e9}));
    dp[1][0].second = 0;
    for (int i = 2; i <= l.size(); i++) {
        dp[0] = dp[1];
        
        for (int j = 0; j <= n; j++) {
            if (j >= k) {
                if (j < n && j != 0) {
                    dp[1][j + 1].first = max(dp[0][j - 1].second, dp[0][j - k].first) + l[i - 1];
                }
                dp[1][j].second = max(dp[0][j].second, dp[0][j].first);
            }
            else {
                if (j < n && j != 0) {
                    dp[1][j + 1].first = dp[0][j - 1].second + l[i - 1];
                    
                }
                dp[1][j].second = max(dp[0][j].second, dp[0][j].first);
            }
        }
    }
    
    for (int i = 0; i <= n; i++) {
        ans[i] = max(ans[i], max(dp.back()[i].second, dp.back()[i].first));
    }
    return ans;
}


int sol2(int n, int k, vector<int> t, vector<int> fakel) {

    vector<bool> used(n);
    vector<int> ans(n + 1, -1e9);
    ans[0] = 0;
    for (int j = 0; j < n; j++) {
        if (used[j]) {
            continue;
        }
        int pos = t[j];

        vector<int> l;
        l.push_back(fakel[j]);
        while (pos != j) {
            used[pos] = true;
            l.push_back(fakel[pos]);
            pos = t[pos];
        }
        
        vector<int> res = count_dp(l, n, k);
        
        for (int i = n; i >= 0; i--) {
            for (int ii = 0; ii <= i; ii++) {
                ans[i] = max(ans[i], ans[i - ii] + res[ii]);
            }
        }
        used[j] = true;
    }
    
    return *max_element(ans.begin(), ans.end());

    
}

signed main() {
    int n, k;
    cin >> n >> k;
    vector<int> t(n);
    vector<int> l(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i] >> l[i];
    }
    cout << sol2(n, k, t, l);
    
    
}


/*
 8 2
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
 */

/* {
 8 3
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
 */
