//
//  main.cpp
//  D
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <random>
#include <algorithm>
#include <vector>


using namespace std;


vector<pair<int, int>> count_dp(vector<int> &l, int n, int k) {
    pair<int, int> dp[2][n + 1];
    dp[1][1].first = l[0];
    for (int i = 2; i <= l.size(); i++) {
        copy(dp[1], dp[1] + n + 1, dp[0]);
        for (int j = 0; j <= n; j++) {
            if (j >= k) {
                if (j < n && j != 0) {
                    dp[1][j + 1].first = max(dp[0][j - 1].second, dp[0][j - k].first) + l[i - 1];
                }
                dp[1][j].second = max(dp[0][j].second, dp[0][j].first);
            }
            else {
                if (j < n && j != 0) {
                    dp[1][j + 1].first = dp[0][j - 1].second + l[i - 1];
                    
                }
                dp[1][j].second = max(dp[0][j].second, dp[0][j].first);
            }
        }
    }
    
    int ans[n + 1];
    fill(ans, ans + n + 1, -1e9);
    for (int i = 0; i <= n - 1; i++) {
        ans[i + 1] = max(ans[i + 1], dp[1][i].second);
    }
    for (int i = 0; i <= n - k; i++) {
        ans[i + k] = max(ans[i + k], dp[1][i].first);
    }
    for (int i = 0; i < n + 1; i++) {
        dp[1][i] = make_pair(-1e9, -1e9);
    }
    dp[1][0].second = 0;
    for (int i = 2; i <= l.size(); i++) {
        copy(dp[1], dp[1] + n + 1, dp[0]);
        
        for (int j = 0; j <= n; j++) {
            if (j >= k) {
                if (j < n && j != 0) {
                    dp[1][j + 1].first = max(dp[0][j - 1].second, dp[0][j - k].first) + l[i - 1];
                }
                dp[1][j].second = max(dp[0][j].second, dp[0][j].first);
            }
            else {
                if (j < n && j != 0) {
                    dp[1][j + 1].first = dp[0][j - 1].second + l[i - 1];
                    
                }
                dp[1][j].second = max(dp[0][j].second, dp[0][j].first);
            }
        }
    }
    
    for (int i = 0; i <= n; i++) {
        ans[i] = max(ans[i], max(dp[1][i].second, dp[1][i].first));
    }
    vector<pair<int, int>> anss;
    anss.push_back({0, ans[0]});
    for (int i = 1; i < n + 1; i++) {
        if (ans[i] != ans[i - 1]) {
            anss.push_back({i, ans[i]});
        }
    }
    
    return anss;
}


int sol2(int n, int k, vector<int> &t, vector<int> &fakel) {

    vector<bool> used(n);
    int ans[n + 1];
    fill(ans, ans + n + 1, -1e9);
    ans[0] = 0;
    int tester = 0;
    for (int j = 0; j < n; j++) {
        if (used[j]) {
            continue;
        }
        int pos = t[j];

        vector<int> l;
        l.push_back(fakel[j]);
        while (pos != j) {
            used[pos] = true;
            l.push_back(fakel[pos]);
            pos = t[pos];
        }
        
        vector<pair<int, int>> res = count_dp(l, n, k);
        
        for (int i = n; i >= 0; i--) {
            for (auto [k, v] : res) {
                if (k > i) {
                    break;
                }
                ans[i] = max(ans[i], ans[i - k] + v);
            }
        }
        used[j] = true;
    }
    
    return *max_element(ans, ans + n + 1);

    
}

signed main() {
    int n, k;
    cin >> n >> k;
    vector<int> t(n);
    vector<int> l(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i] >> l[i];
    }
    cout << sol2(n, k, t, l);
    
    
}


/*
 8 2
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
 */

/* {
 8 3
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
 */
