#include <bits/stdc++.h>

using namespace std;
#define ll long long
ll cur = 0;
vector <vector <int>> t, f;
vector <int> a;

inline void update_f(vector <int>& fen, int x, int z) {
    for (++x; x < fen.size(); x = (x | (x - 1)) + 1) fen[x] += z;
}

inline int get_pref(vector <int>& fen, int i) {
    int ans = 0;
    for (++i; i > 0; i = (i & (i - 1))) ans += fen[i];
    return ans;
}

inline int get_seg(vector <int>& fen, int l, int r) {
    return get_pref(fen, r) - get_pref(fen, l - 1);
}

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = {a[l]};
        f[v] = {0, 1};
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    int one = 0, two = 0;
    while (one < t[2 * v].size() || two < t[2 * v + 1].size()) {
        if (one == t[2 * v].size()) {
            t[v].push_back(t[2 * v + 1][two]);
            ++two;
        }
         else if (two == t[2 * v + 1].size()) {
            cur += t[2 * v + 1].size();
            t[v].push_back(t[2 * v][one]);
            ++one;
        }
        else if (t[2 * v][one] < t[2 * v + 1][two]) {
            cur += two;
            t[v].push_back(t[2 * v][one]);
            ++one;
        } else {
            t[v].push_back(t[2 * v + 1][two]);
            ++two;
        }
    }
    f[v].resize(r - l + 2);
    for (int i = 0; i < r - l + 1; ++i) {
        update_f(f[v], i, 1);
    }
}

void update(int v, int l, int r, int i, int x) {
    if (l > i || i > r) return;
    update_f(f[v], lower_bound(t[v].begin(), t[v].end(), x) - t[v].begin(), -1);
    if (l == r) return;
    int m = (l + r) / 2;
    update(2 * v, l, m, i, x);
    update(2 * v + 1, m + 1, r, i, x);
}

int kol_more(int v, int l, int r, int A, int B, int x) {
    if (l > B || A > r) return 0;
    if (A <= l && r <= B) {
        auto it = lower_bound(t[v].begin(), t[v].end(), x);
        int in = it - t[v].begin();
        int ans = get_seg(f[v], in, r - l);
        return ans;
    }
    int m = (l + r) / 2;
    return kol_more(2 * v, l, m, A, B, x) + kol_more(2 * v + 1, m + 1, r, A, B, x);
}

int kol_less(int v, int l, int r, int A, int B, int x) {
    if (l > B || A > r) return 0;
    if (A <= l && r <= B) {
        auto it = lower_bound(t[v].begin(), t[v].end(), x);
        int in = it - t[v].begin();
        int ans = get_seg(f[v], 0, in - 1);
        return ans;
    }
    int m = (l + r) / 2;
    return kol_less(2 * v, l, m, A, B, x) + kol_less(2 * v + 1, m + 1, r, A, B, x);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    int len = 1 << (int)ceil(log2(n));
    t.resize(2 * len);
    f.resize(2 * len);
    a.resize(len);
    for (int i = n; i < len; ++i) {
        a[i] = i + 1;
    }
    vector <int> index(n + 1);
    for (int i = 0; i < n; ++i){
        cin >> a[i];
        index[a[i]] = i;
    }
    build(1, 0, len - 1);
    cout << cur << " ";
    for (int _ = 0; _ < n - 2; ++_) {
        int x;
        cin >> x;
        update(1, 0, len - 1, index[x], x);
        cur -= (kol_more(1, 0, len - 1, 0, index[x] - 1, x) + kol_less(1, 0, len - 1, index[x] + 1, n - 1, x));
        cout << cur << " ";
    }
    return 0;
}
