#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>

using namespace std;

vector<int> tree[400000];
vector<int> a;

void build(int v, int l, int r) {
    tree[v].clear();
    if (l + 1 == r) {
        tree[v] = {a[l]};
        return;
    }
    build(v * 2 + 1, l, (l + r) / 2);
    build(v * 2 + 2, (l + r) / 2, r);
    tree[v].resize(tree[v * 2 + 1].size() + tree[v * 2 + 2].size());
    merge(tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), tree[v * 2 + 2].begin(), tree[v * 2 + 2].end(), tree[v].begin());
}

int find(int v, int l, int r, int ql, int qr, int k) {
    if (qr <= l || ql >= r) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return lower_bound(tree[v].begin(), tree[v].end(), k) - tree[v].begin();
    } else {
        return find(v * 2 + 1, l, (l + r) / 2, ql, qr, k) + find(v * 2 + 2, (l + r) / 2, r, ql, qr, k);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build(0, 0, n);
    long long cnt = 0;
    for (int i = 0; i < n; ++i) {
        cnt += find(0, 0, n, i + 1, n, a[i]);
    }
    set<int> del;
    int sqr = 850;
    vector<pair<int, int>> now;
    map<int, int> ind;
    for (int i = 0; i < n; ++i) {
        ind[a[i]] = i;
    }
    cout << cnt << " ";

}