#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>

using namespace std;

vector<int> tree[400000];
int a[100000];

inline void build(int v, int l, int r) {
    tree[v].clear();
    if (l + 1 == r) {
        tree[v] = {a[l]};
        return;
    }
    build(v * 2 + 1, l, (l + r) / 2);
    build(v * 2 + 2, (l + r) / 2, r);
    tree[v].resize(tree[v * 2 + 1].size() + tree[v * 2 + 2].size());
    merge(tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), tree[v * 2 + 2].begin(), tree[v * 2 + 2].end(), tree[v].begin());
}

inline int find(int v, int l, int r, int ql, int qr, int k) {
    if (qr <= l || ql >= r) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return lower_bound(tree[v].begin(), tree[v].end(), k) - tree[v].begin();
    } else {
        return find(v * 2 + 1, l, (l + r) / 2, ql, qr, k) + find(v * 2 + 2, (l + r) / 2, r, ql, qr, k);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build(0, 0, n);
    long long cnt = 0;
    for (int i = 0; i < n; ++i) {
        cnt += find(0, 0, n, i + 1, n, a[i]);
    }
    set<int> del;
    int sqr = 600;
    vector<pair<int, int>> now;
    map<int, int> ind;
    for (int i = 0; i < n; ++i) {
        ind[a[i]] = i;
    }
    cout << cnt << " ";
    int sz = n;
    for (int i = 0; i < n - 2; ++i) {
        if (i % sqr == 0 && i > 0) {
            int ind1 = 0;
            for (int j = 0; j < sz; ++j) {
                if (del.count(j) == 0) {
                    a[ind1] = a[j];
                    ind1 += 1;
                }
            }
            build(0, 0, ind1);
            now.clear();
            ind.clear();
            for (int j = 0; j < ind1; ++j) {
                ind[a[j]] = j;
            }
            del.clear();
            sz = ind1;
        }
        int c;
        cin >> c;
        int now_ind = ind[c];
        for (int j = 0; j < now.size(); ++j) {
            if (now[j].first < now_ind && now[j].second > c || now[j].first > now_ind && now[j].second < c) {
                cnt += 1;
            }
        }
        cnt -= now_ind - find(0, 0, sz, 0, now_ind, c) + find(0, 0, sz, now_ind + 1, sz, c);
        cout << cnt << " ";
        del.insert(now_ind);
        now.emplace_back(now_ind, c);
    }
}