#include <bits/stdc++.h>
using namespace std;

class fenwick_tree {
  private:
    int n;
    vector<int> fenw;
  public:
    fenwick_tree(int _n) : n(_n) {
      fenw.assign(n, 0);
    }

    int query(int x) {
      int ans = 0;
      while (x > 0) {
        ans += fenw[x];
        x -= (x & -x);
      }
      return ans;
    }

    void update(int x, int val) {
      while (x < n) {
        fenw[x] += val;
        x += (x & -x);
      }
    }
};

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> a(n), change(n + 1, 0);
  long long ans = 0;
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    for (int j = 0; j < i; j++) {
      if (a[j] > a[i]) {
        change[a[i]]++; ans++;
      }
    }
  }
  cout << ans << ' ';
  for (int q = 0; q < n - 2; q++) {
    int x;
    cin >> x;
    ans -= change[x];
    change[x] = 0;
    for (int i = 0, found = 0; i < n; i++) {
      if (found) {
        if (a[i] != -1 && x > a[i]) {
          change[a[i]]--; ans--;
        }
      } else if (a[i] == x) {
        a[i] = -1;
        found = 1;
      }
    }
    cout << ans << ' ';
  }
  cout << '\n';
  return 0;
}