#include <bits/stdc++.h>
using namespace std;

class fenwick_tree {
  private:
    int n;
    vector<int> fenw, st;
  public:
    fenwick_tree(int _n) : n(_n) {
      fenw.assign(n, 0);
    }

    int query(int x) {
      int ans = 0;
      while (x > 0) {
        ans += fenw[x];
        x -= (x & -x);
      }
      return ans;
    }

    void update(int x, int val) {
      while (x < n) {
        st.push_back(x);
        fenw[x] += val;
        x += (x & -x);
      }
    }

    void reset() {
      for (auto& x : st) fenw[x] = 0;
      st.clear();
    }
};

struct query {
  int x, l, r, val, idx;
};
vector<query> queries, sorted_queries;
vector<int> ans_q;
fenwick_tree fenw(0);

void solve(int l, int r) {
  if (l == r) return;
  int mid = (l + r) / 2;
  solve(l, mid);
  solve(mid + 1, r); 
  int ptr = l;
  int i = mid + 1, j = l;
  for (; i <= r; i++) {
    while (j <= mid && queries[j].x <= queries[i].x) {
      if (queries[j].idx == -1) {
        fenw.update(queries[j].l, queries[j].val);
        fenw.update(queries[j].r + 1, -queries[j].val);
      }
      sorted_queries[ptr++] = queries[j++];
    }
    if (queries[i].idx != -1) {  
      ans_q[queries[i].idx] += fenw.query(queries[i].l);
    }
    sorted_queries[ptr++] = queries[i];
  }
  while (j <= mid) {
    sorted_queries[ptr++] = queries[j++];
  }
  for (i = l; i <= r; i++) {
    queries[i] = sorted_queries[i];
  }
  fenw.reset();
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> a(n), change(n + 1, 0), pos(n + 1);
  for (int i = 0; i < n; i++) cin >> a[i], pos[a[i]] = i;
  fenwick_tree fenw1(n + 1);
  for (int i = 0; i < n; i++) change[a[i]] += fenw1.query(n) - fenw1.query(a[i]), fenw1.update(a[i], +1);
  long long ans = accumulate(change.begin(), change.end(), 0ll);
  fenw1 = fenwick_tree(n + 1);
  for (int i = n - 1; i >= 0; i--) change[a[i]] += fenw1.query(a[i]), fenw1.update(a[i], +1);
  int idx = 0;
  for (int i = 0; i < n; i++) {
    queries.push_back({i, a[i], a[i], +change[a[i]], -1});
    queries.push_back({i + 1, a[i], a[i], -change[a[i]], -1});
  }
  for (int i = 0; i < n - 2; i++) {
    int x;
    cin >> x;
    queries.push_back({pos[x], x, -1, 0, idx++});
    queries.push_back({0, x + 1, n, -1, -1});
    queries.push_back({pos[x], x + 1, n, +1, -1});
    queries.push_back({pos[x] + 1, 1, x - 1, -1, -1});
  }
  /*for (auto& q : queries) {
    if (q.r == -1) cout << q.x << ' ' << q.l << '\n';
    else cout << q.x << ' ' << q.l << ' ' << q.r << ' ' << q.val << '\n';
  }*/
  sorted_queries.resize((int) queries.size());
  ans_q.assign(idx, 0);
  fenw = fenwick_tree(n + 1);
  solve(0, (int) queries.size() - 1);
  cout << ans << ' ';
  for (auto& x : ans_q) {
    ans -= x;
    cout << ans << ' ';
  }
  cout << '\n';
  return 0;
}