﻿#pragma unroll_loops

#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

#define ll long long

#define VI vector<int>
#define VB vector<bool>
#define VS vector<string>
#define VC vector<char>
#define PAR pair<int, int>
#define VP vector<PAR>
#define VVI vector<VI>
#define VVC vector<VC>
#define VVB vector<VB>
#define VVP vector<VP>
#define endl '\n'

template<class T>
void print(const vector<T> v) {
	for (auto val : v) {
		cout << val << ' ';
	}
	cout << endl;
}

int n, k;
VI vt, vl;
set<PAR> vals;

int solve(int spare) {
	if (spare <= 1) {
		return 0;
	}
	int result = 0;
	PAR maxnum = *vals.rbegin();
	vals.erase(maxnum);
	int nexti = vt[maxnum.second];
	if (vals.find({ vl[nexti], nexti }) != vals.end() && nexti != vals.rbegin() -> second) {
		vals.erase({ vl[nexti], nexti });
		result = max(result, solve(spare - 2) + maxnum.first);
		vals.insert({ vl[nexti], nexti });
	}
	if (spare > k) {
		result = max(result, solve(spare - 1 - k) + maxnum.first);
	}
	vals.insert(maxnum);
	return result;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	cin >> n >> k;
	vt.resize(n);
	vl.resize(n);
	
	for (int i = 0; i < n; ++i) {
		cin >> vt[i] >> vl[i];
		vals.insert({ vl[i], i });
	}

	cout << solve(n) << endl;
	
	return 0;
}
