#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast,no-stack-protector")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct node {
    int sum;
    node() {sum = 0;}
    node(int sum): sum(sum) {}
    node(const node& l, const node& r) {
        sum = l.sum + r.sum;
    }
};

void upd(vector<node>& tree, int qi, int d, int i, int L, int R) {
    if (qi < L || R <= qi) return;
    if (L + 1 == R) {
        tree[i].sum += d;
        return;
    }
    int m = (L + R) / 2;
    upd(tree, qi, d, 2 * i + 1, L, m);
    upd(tree, qi, d, 2 * i + 2, m, R);
    tree[i] = node(tree[2 * i + 1], tree[2 * i + 2]);
}

int req(vector<node>& tree, int qL, int qR, int i, int L, int R) {
    if (qR <= L || R <= qL) return 0;
    if (qL <= L && R <= qR) return tree[i].sum;
    int m = (L + R) / 2;
    int r1 = req(tree, qL, qR, 2 * i + 1, L, m);
    int r2 = req(tree, qL, qR, 2 * i + 2, m, R);
    return r1 + r2;
}

// Number of elements lower than x is req(tree, 0, x, 0, 0, n)
// Number of elements greater than x is req(tree, x + 1, n + 1, 0, 0, n)

int n;
vector<int> p;
vector<int> del;

void input() {
    cin >> n;
    p = vector<int> (n);
    for (int i = 0; i < n; ++i) cin >> p[i];
    del = vector<int> (n - 2);
    for (int i = 0; i < n - 2; ++i) cin >> del[i];
}

vector<int> solve() {
    const int k = 316;
    int bc = (n + k - 1) / k;
    
    set<int> all; for (int i = 1; i <= n; ++i) all.insert(i);
    vector<int> where (n + 1, -1);
    for (int i = 0; i < n; ++i) where[p[i]] = i;
    for (int i = 0; i < n - 2; ++i) all.erase(del[i]);
    vector<int> add = del;
    int l1 = *(all.begin()), l2 = *(all.rbegin());
    add.push_back(l1); add.push_back(l2);
    reverse(add.begin(), add.end());
    
    vector<int> ans (n + 1, 0); int sum = 0;
    vector<int> curr (n, 0);
    vector<node> b [bc]; fill(b, b + bc, vector<node>(4 * (n + 1), 0));
    for (int j = 0; j < n; ++j) {
        int x = add[j];
        if (x == 4) {
            // flex
        }
        int bi = where[x] / k;
        for (int i = 0; i < bi; ++i) {
            sum += req(b[i], x + 1, n + 1, 0, 0, n + 1);
        }
        for (int i = bi * k; i < where[x]; ++i) {
            sum += (curr[i] != 0 && curr[i] > x);
        }
        for (int i = where[x] + 1; i < (bi + 1) * k && i < n; ++i) {
            sum += (curr[i] != 0 && x > curr[i]);
        }
        for (int i = bi + 1; i < bc; ++i) {
            sum += req(b[i], 0, x, 0, 0, n + 1);
        }
        curr[where[x]] = x;
        upd(b[bi], x, 1, 0, 0, n + 1);
        ans[j + 1] = sum;
    }
    vector<int> ret (n - 1);
    for (int i = 0; i < n - 1; ++i) {
        ret[i] = ans[n - i];
    }
    return ret;
}

signed main() {
    input();
    vector<int> ret = solve();
    for (int i = 0; i < n - 1; ++i) {
        cout << ret[i] << ' ';
    }
    cout << '\n';
    /*int n; cin >> n;
    vector<int> p (n);
    vector<int> where (n + 1, -1);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        where[p[i]] = i;
    }
    vector<int> curr = p;
    vector<int> add (n - 2);
    for (int qwerty = 0; qwerty < n - 2; ++qwerty) {
        int x; cin >> x;
        add[n - 3 - qwerty] = x;
        curr[where[x]] = 0;
    }
    
    vector<int> ans (n - 1);
    int total = 0;
    int first = -1;
    for (int i = 0; i < n; ++i) {
        if (curr[i] == 0) continue;
        if (first == -1) first = curr[i];
        else total = (curr[i] < first);
    }
    
    for (int i = 0; i < n - 1; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';*/
}
