﻿#pragma GCC target("popcnt")
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <immintrin.h>

#if EVAL
#define __popcnt(a) __builtin_popcount(a)
#endif // EVAl


constexpr int MAXN = 1e1 + 5;

int n, k, t[MAXN], l[MAXN];
std::vector<uint32_t> help;

int getCost(uint32_t a) {
	int res = 0;
	for (int i = 0; i < n; i++) {
		if ((a >> i) & 1) {
			res += l[i];
		}
	}
	return res;
}



bool check(uint32_t mask) {
	if (__popcnt(mask) == 5) {
		char arr[10] = { 0, 0, 1, 1, 2, 2, 3, 3, 4, 4 };
		char nm[5], sc[5];
		for (int i = 0, j = 0; i < 10; i++) {
			if ((mask >> i) & 1) {
				nm[j++] = i;
			}
		}
		do {
			std::fill(sc, sc + 5, 0);
			for (int i = 0; i < n; i++) {
				if ((nm[arr[i]] == i) || (t[nm[arr[i]]] == i)) {
					sc[arr[i]] += k;
				} else {
					sc[arr[i]]++;
				}
			}
			bool may = true;
			for (int i = 0; i < 5; i++) {
				if (sc[i] < (2 * k)) {
					may = false;
				}
			}
			if (may) {
				return true;
			}
		} while (std::next_permutation(arr, arr + 10));
		return false;
	} else {
		char arr[10];
		char nm[5], sc[5];
		char pc = __popcnt(mask);

		for (int i = 0, j = 0; i < n; i++) {
			if ((mask >> i) & 1) {
				nm[j++] = i;
			}
		}

		for (uint32_t m = 0; m < (1 << 2 * n); m++) {
			std::fill(sc, sc + 5, 0);
			bool may = true;
			for (int i = 0; i < n; i++) {
				if (((m >> 2 * i) & 3) >= pc) {
					may = false;
					break;
				}
			}
			if (!may) {
				continue;
			}
			for (int i = 0; i < n; i++) {
				arr[i] = (m >> 2 * i) & 3;
			}
			for (int i = 0; i < n; i++) {
				if ((nm[arr[i]] == i) || (t[nm[arr[i]]] == i)) {
					sc[arr[i]] += k;
				} else {
					sc[arr[i]]++;
				}
			}
			for (int i = 0; i < pc; i++) {
				if (sc[i] < (2 * k)) {
					may = false;
				}
			}
			if (may) {
				return true;
			}
		}
		return false;
	}
}


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	std::cin >> n >> k;
	for (int i = 0; i < n; i++) {
		std::cin >> t[i] >> l[i];
	}

	if (n <= 10) {
		for (uint32_t mask = 0; mask < (1u << n); mask++) {
			if (__popcnt(mask) <= (n / 2)) {
				help.push_back(mask);
			}
		}

		std::sort(help.begin(), help.end(), [](uint32_t a, uint32_t b) {return getCost(a) > getCost(b); });
		for (const uint32_t &mask : help) {
			if (check(mask)) {
				std::cerr << "res: ";
				std::cout << getCost(mask) << std::endl;
				return 0;
			}
		}
	}

	std::cout << "something went wrong!!!!!!!!!\n" << std::endl;
	exit(1);

	std::cout.flush();
	return 0;
}