﻿#pragma GCC target("popcnt")
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <immintrin.h>

#if EVAL
#define __popcnt(a) __builtin_popcount(a)
#endif // EVAl


constexpr int MAXN = 7e2 + 5;

int n, k, t[MAXN], l[MAXN];
std::vector<uint32_t> help;

int getCost(uint32_t a) {
	int res = 0;
	for (int i = 0; i < n; i++) {
		if ((a >> i) & 1) {
			res += l[i];
		}
	}
	return res;
}
bool check(uint32_t mask) {
	if (__popcnt(mask) == 5) {
		char arr[10] = { 0, 0, 1, 1, 2, 2, 3, 3, 4, 4 };
		char nm[5], sc[5];
		for (int i = 0, j = 0; i < 10; i++) {
			if ((mask >> i) & 1) {
				nm[j++] = i;
			}
		}
		do {
			std::fill(sc, sc + 5, 0);
			for (int i = 0; i < n; i++) {
				if ((nm[arr[i]] == i) || (t[nm[arr[i]]] == i)) {
					sc[arr[i]] += k;
				} else {
					sc[arr[i]]++;
				}
			}
			bool may = true;
			for (int i = 0; i < 5; i++) {
				if (sc[i] < (2 * k)) {
					may = false;
				}
			}
			if (may) {
				return true;
			}
		} while (std::next_permutation(arr, arr + 10));
		return false;
	} else {
		char arr[10];
		char nm[5], sc[5];
		char pc = __popcnt(mask);

		for (int i = 0, j = 0; i < n; i++) {
			if ((mask >> i) & 1) {
				nm[j++] = i;
			}
		}

		for (uint32_t m = 0; m < (1 << 2 * n); m++) {
			std::fill(sc, sc + 5, 0);
			bool may = true;
			for (int i = 0; i < n; i++) {
				if (((m >> 2 * i) & 3) >= pc) {
					may = false;
					break;
				}
			}
			if (!may) {
				continue;
			}
			for (int i = 0; i < n; i++) {
				arr[i] = (m >> 2 * i) & 3;
			}
			for (int i = 0; i < n; i++) {
				if ((nm[arr[i]] == i) || (t[nm[arr[i]]] == i)) {
					sc[arr[i]] += k;
				} else {
					sc[arr[i]]++;
				}
			}
			for (int i = 0; i < pc; i++) {
				if (sc[i] < (2 * k)) {
					may = false;
				}
			}
			if (may) {
				return true;
			}
		}
		return false;
	}
}


int dp[MAXN][MAXN][2];


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	std::cin >> n >> k;
	for (int i = 0; i < n; i++) {
		std::cin >> t[i] >> l[i];
	}

	if (k == -1) {
		std::sort(l, l + n);
		std::reverse(l, l + n);
		std::cout << std::accumulate(l, l + (n / 2), 0) << std::endl;
		return 0;
	}

	if (n <= 10) {
		for (uint32_t mask = 0; mask < (1u << n); mask++) {
			if (__popcnt(mask) <= (n / 2)) {
				help.push_back(mask);
			}
		}

		std::sort(help.begin(), help.end(), [](uint32_t a, uint32_t b) {return getCost(a) > getCost(b); });
		for (const uint32_t &mask : help) {
			if (check(mask)) {
				std::cerr << "res: ";
				std::cout << getCost(mask) << std::endl;
				return 0;
			}
		}
		std::cout << "something went wrong!!!!!!!!!\n" << std::endl;
		exit(1);
	}

	std::vector<int> p;
	p.push_back(0);
	{
		std::vector<bool> used(n, false);
		used[p.back()] = true;
		while (!used[t[p.back()]]) {
			used[t[p.back()]] = true;
			p.push_back(t[p.back()]);
		}
		if (p.size() != n) {
			exit(1);
		}
		std::rotate(p.begin(), p.begin() + (n - 1), p.end());
	}
	std::for_each(p.begin(), p.end(), [](int &val) {val = l[val]; });
	if (p[0] != 0) {
		exit(1);
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			dp[i][j][0] = dp[i][j][1] = -1e9;
		}
	}
	dp[0][0][0] = 0;
	int ans = 0;
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < n; j++) {
			{
				{
					if ((j + 2 * k) < n) {
						dp[i][j][0] = std::max(dp[i][j][0], dp[i - 1][j + 2 * k][1] + p[i]);
					}
					if ((j + 2 * k - 1) < n) {
						dp[i][j][0] = std::max(dp[i][j][0], dp[i - 1][j + (2 * k - 1)][0] + p[i]);
					}
				}
				{
					if ((j + k) < n) {
						dp[i][j][0] = std::max(dp[i][j][0], dp[i - 1][j + k][0] + p[i]);
					}
				}
				dp[i][j][0] = std::max(dp[i][j][0], dp[i - 1][j][1]);
				if (j > 0) {
					dp[i][j][0] = std::max(dp[i][j][0], dp[i - 1][j - 1][0]);
				}
				if (dp[i][j][0] < 0) {
					dp[i][j][0] = -1e9;
				}
			}
			{
				{
					if ((j + k) < n) {
						dp[i][j][1] = std::max(dp[i][j][1], dp[i - 1][j + k][1] + p[i]);
					}
					if ((j + (k - 1)) < n) {
						dp[i][j][1] = std::max(dp[i][j][1], dp[i - 1][j + (k - 1)][0] + p[i]);
					}
				}
				{
					dp[i][j][1] = std::max(dp[i][j][1], dp[i - 1][j][0] + p[i]);
				}
				if (dp[i][j][1] < 0) {
					dp[i][j][1] = -1e9;
				}
			}
			ans = std::max(ans, *std::max_element(dp[i][j], dp[i][j] + 2));
		}
	}

	std::cerr << "res: ";
	std::cout << ans << '\n';

	std::cout.flush();
	return 0;
}

/*
4 2
1 2
2 3
3 4
0 0
*/