#include <bits/stdc++.h>

using namespace std;

int n, m, k;

vector <int> fen_tree(1e5 + 10), a(1e5 + 10), r_up(1e5 + 10), p(4e5 + 100);

struct SegTree {
    int min, max, sum, kmin, min1, max1;
};

vector <SegTree> t(4e5 + 100);

void add_fenwik_tree(int pos, int val) {
    for (int v = pos; v <= n; v |= (v + 1))
        fen_tree[v] += val;
}

int query_sum_fen_tree(int l) {
    int ans = 0;
    for (int v = l; v >= 0; v = (v & (v + 1)) - 1)
        ans += fen_tree[v];
    return ans;
}

SegTree apply(SegTree a, SegTree b) {
    SegTree ans;
    if (a.min == b.min) ans.kmin = a.kmin + b.kmin;
    else if (a.min > b.min) ans.kmin = b.kmin;
    else ans.kmin = a.kmin;
    ans.min = min(a.min, b.min);
    ans.max = max(a.max, b.max);
    ans.min1 = min(a.min1, b.min1);
    ans.max1 = max(a.max1, b.max1);
    ans.sum = a.sum + b.sum;
    return ans;
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = {r_up[tl], r_up[tl], r_up[tl], 1, a[tl], a[tl]};
    } else {
        int tm = (tl + tr) >> 1;
        build(v << 1, tl, tm);
        build(v << 1 | 1, tm + 1, tr);
        t[v] = apply(t[v << 1], t[v << 1 | 1]);
    }
}

void push(int v, int tl, int tr) {
    if (!p[v] || v * 2 + 1 > 4e5 + 10) return;
    int tm = (tl + tr) >> 1;
    t[v << 1].sum += p[v] * (tm - tl + 1) + (t[v << 1].min ? 0 : t[v << 1].kmin);
    t[v << 1 | 1].sum += p[v] * (tr - tm) + (t[v << 1 | 1].min ? 0 : t[v << 1 | 1].kmin);
    t[v << 1].min = (t[v << 1].min ? t[v << 1].min + p[v] : 0);
    t[v << 1].max = (t[v << 1].max ? t[v << 1].max + p[v] : 0);
    t[v << 1 | 1].min = (t[v << 1 | 1].min ? t[v << 1 | 1].min + p[v] : 0);
    t[v << 1 | 1].max = (t[v << 1 | 1].max ? t[v << 1 | 1].max + p[v] : 0);
    p[v << 1] += p[v];
    p[v << 1 | 1] += p[v];
    p[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int val) {
    push(v, tl, tr);
    if (tl > r || l > tr || t[v].min1 > val) return;
    if (l <= tl && tr <= r && t[v].max1 < val) {
        p[v] += -1;
        t[v].sum += (tr - tl + 1) * (-1) + (t[v].min ? 0 : t[v].kmin);
        t[v].min = (t[v].min ? t[v].min - 1 : 0);
        t[v].max = (t[v].max ? t[v].max - 1 : 0);
    } else {
        int tm = (tl + tr) >> 1;
        update(v << 1, tl, tm, l, r, val);
        update(v << 1 | 1, tm + 1, tr, l, r, val);
        t[v] = apply(t[v << 1], t[v << 1 | 1]);
    }
}

void new_val(int v, int tl, int tr, int pos, int val) {
    push(v, tl, tr);
    if (tl == tr) {
        t[v] = {val, val, val, 1, a[tl], a[tl]};
    } else {
        int tm = (tl + tr) >> 1;
        if (pos <= tm) new_val(v << 1, tl, tm, pos, val);
        else new_val(v << 1 | 1, tm + 1, tr, pos, val);
        t[v] = apply(t[v << 1], t[v << 1 | 1]);
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    map <int, int> inx;
    for (int i = 0; i < n; ++i)
        cin >> a[i], inx[a[i]] = i;

    { // array r_up
        for (int i = 0; i < n; ++i) {
            r_up[i] = query_sum_fen_tree(n) - query_sum_fen_tree(max(a[i] - 1, 0));
            add_fenwik_tree(a[i], 1);
        }
    }

    build(1, 0, n - 1);

    cout << t[1].sum << '\n';

    for (int i = 0; i < n - 2; ++i) {
        int q; cin >> q;
        int pos = inx[q];
        new_val(1, 0, n - 1, pos, 0);
        update(1, 0, n - 1, pos + 1, n - 1, q);
        cout << t[1].sum << '\n';
    }

    return 0;
}