#include <bits/stdc++.h>

using namespace std;

int n, m, k;
vector <int> a(1e5 + 1000);
vector <vector <int>> t(1e5 + 1000);

void MERGE(int v) {
    t[v].clear();
    int a = v * 2, b = v * 2 + 1;
    int l = 0, r = 0;
    while (l != t[a].size() && r != t[b].size()) {
        if (t[a][l] > t[b][r])
            t[v].push_back(t[b][r++]);
        else
            t[v].push_back(t[a][l++]);
    }
    while (l != t[a].size())
        t[v].push_back(t[a][l++]);
    while (r != t[b].size())
        t[v].push_back(t[b][r++]);
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v].push_back(a[tl]);
    } else {
        int tm = (tl + tr) >> 1;
        build(v << 1, tl, tm);
        build(v << 1 | 1, tm + 1, tr);
        MERGE(v);
    }
}

int query_upper(int v, int tl, int tr, int l, int r, int x) {
    if (l > tr || tl > r || l > r) return 0;
    if (l <= tl && tr <= r) {
        int UP = (upper_bound(t[v].begin(), t[v].end(), x) - t[v].begin());
        return t[v].size() - UP;
    }
    int tm = (tl + tr) >> 1;
    int L = query_upper(v << 1, tl, tm, l, r, x);
    int R = query_upper(v << 1 | 1, tm + 1, tr, l, r, x);
    return L + R;
}

int query_lower(int v, int tl, int tr, int l, int r, int x) {
    if (l > tr || tl > r || l > r) return 0;
    if (l <= tl && tr <= r) {
        int LB = lower_bound(t[v].begin(), t[v].end(), x) - t[v].begin();
        return LB;
    }
    int tm = (tl + tr) >> 1;
    int L = query_lower(v << 1, tl, tm, l, r, x);
    int R = query_lower(v << 1 | 1, tm + 1, tr, l, r, x);
    return L + R;
}

void update (int v, int tl, int tr, int pos) {
    if (tl == tr) {
        t[v].clear();
    } else {
        int tm = (tl + tr) >> 1;
        if (pos <= tm) update(v << 1, tl, tm, pos);
        else update(v << 1 | 1, tm + 1, tr, pos);
        MERGE(v);
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    map <int, int> inx;
    for (int i = 0; i < n; ++i)
        cin >> a[i], inx[a[i]] = i;
    build(1, 0, n - 1);
    long long sum = 0;
    for (int i = 0; i < n; ++i)
        sum += query_lower(1, 0, n - 1, i, n - 1, a[i]);
    cout << sum << ' ';
    for (int i = 0; i < n - 2; ++i) {
        int q; cin >> q;
        int pos = inx[q];
        sum -= query_lower(1, 0, n - 1, pos + 1, n - 1, q);
        sum -= query_upper(1, 0, n - 1, 0, pos - 1, q);
        update(1, 0, n - 1, pos);
        cout << sum << ' ';
    }
    return 0;
}