#include<iostream>

#define endl '\n'

using namespace std;

const int MAXN=1e5+3;
int nums[MAXN],ind[MAXN];
long long fenwick[MAXN];

void add_tree(int ind, int val, int n){
    while(ind<=n){
        fenwick[ind]+=val;
        ind+=(ind & -ind);
    }
}

long long query(int ind){
    long long res=0;
    while(ind>0){
        res+=fenwick[ind];
        ind-=(ind & -ind);
    }
    return res;
}

long long disorder_score(int n){
    for(int i=0;i<=n;++i){
        fenwick[i]=0;
    }

    long long score=0;
    for(int i=n-1;i>=0;--i){
        if(nums[i]==-1){
            continue;
        }

        score+=query(nums[i]-1);
        add_tree(nums[i], 1, n);
    }

    return score;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin>>n;

    for(int i=0;i<n;++i){
        cin>>nums[i];
        ind[nums[i]-1]=i;
    }

    cout<<disorder_score(n)<<" ";
    for(int i=2;i<n;++i){
        int removed;
        cin>>removed;

        nums[ind[removed-1]]=-1;
        cout<<disorder_score(n)<<" ";
    }
    cout<<endl;
return 0;
}
