#include <iostream>
#include <vector>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int a[MAXN + 5];
int p[MAXN + 5];
int s[MAXN + 5];
int depth[MAXN + 5];
int subtree[MAXN + 5];
vector<int> G[MAXN + 5];

void DFS(int u)
{
    subtree[u] = 1;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p[u])
        {
            if (u != 0) depth[v] = depth[u] + 1;
            DFS(v);
            subtree[u] += subtree[v];
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    stack<int> st;
    for (int i = 1; i <= n; ++ i)
    {
        while (!st.empty() and st.top() < a[i]) st.pop();
        if (st.empty()) p[a[i]] = 0;
        else p[a[i]] = st.top();
        st.push(a[i]);
    }

    for (int i = 1; i <= n; ++ i)
    {
        G[p[i]].push_back(i);
    }

    DFS(0);

    long long ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        ans += subtree[i];
    }
    ans -= n;

    cout << ans << " ";
    for (int i = 1; i <= n - 2; ++ i)
    {
        int u;
        cin >> u;

        int u0 = u;
        while (u0 != 0)
        {
            subtree[u0]--;
            s[p[u0]] = u0;
            u0 = p[u0];
        }

        u0 = 0;
        while (true)
        {
            depth[u0] = min(depth[u0], depth[p[u0]] + 1);
            if (u0 == u) break;
            u0 = s[u0];
        }
        ans -= (depth[u] + subtree[u]);
        depth[u] = depth[p[u]];

        cout << ans << " ";
    }
    cout << endl;

    return 0;
}
