#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int n;
int a[MAXN + 5];
int fw[MAXN + 5];
bool used[MAXN + 5];

void update(int idx, int delta)
{
    while (idx <= n)
    {
        fw[idx] += delta;
        idx += (idx & (-idx));
    }
}

int query(int idx)
{
    int ret = 0;
    while (idx)
    {
        ret += fw[idx];
        idx -= (idx & (-idx));
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    reverse(a + 1, a + n + 1);

    long long ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        ans += query(a[i] - 1);
        update(a[i], 1);
    }

    cout << ans << " ";
    for (int i = 1; i <= n - 2; ++ i)
    {
        int num;
        cin >> num;

        for (int j = 1; j <= n; ++ j)
        {
            fw[j] = 0;
        }

        ans = 0;
        used[num] = true;
        for (int j = 1; j <= n; ++ j)
        {
            if (!used[a[j]])
            {
                ans += query(a[j] - 1);
                update(a[j], 1);
            }
        }

        cout << ans << " ";
    }
    cout << endl;

    return 0;
}
